# This chunk of stuff was generated by App::FatPacker. To find the original
# file's code, look for the end of this BEGIN block or the string 'FATPACK'
BEGIN {
my %fatpacked;

$fatpacked{"PlannedBlackoutJP/Util.pm"} = <<'PLANNEDBLACKOUTJP_UTIL';
  package PlannedBlackoutJP::Util;
  use strict;
  use warnings;
  
  use Exporter qw/import/;
  
  our @EXPORT = qw/is_galapagos/;
  
  sub is_galapagos($) {
      my $env = shift;
      return $env->{HTTP_USER_AGENT} =~ /
          DoCoMo|UP\.Browser|KDDI|SoftBank|Voda[F|f]one|J\-PHONE|DDIPOCKET|
          WILLCOM|iPod|PDA|Mobile|Semulator
      /x;
  }
  
  1;
PLANNEDBLACKOUTJP_UTIL

$fatpacked{"Nana/Mail.pm"} = << 'NANA_MAIL';
package	Nana::Mail;
use 5.8.1;
use strict;
use vars qw($VERSION);
$VERSION = '0.1';

# sendmailpX
$::modifier_sendmail="/var/qmail/bin/sendmail -t";

$Nana::Mail::sendmail=<<EOM;
/var/qmail/bin/sendmail -t
/usr/sbin/sendmail -t
/usr/bin/sendmail -t
EOM

######################################################################

use Jcode;

sub mime_conv {
	my($str)=@_;
	$str=Jcode->new($str)->jis;
	$str=Jcode->new($str)->mime_encode;
	return $str;
}

sub send {
	my(%hash)=@_;
	my $to=&mime_conv($hash{to});
	my $to_name=&mime_conv($hash{to_name});
	my $from=&mime_conv($hash{from});
	my $from_name=&mime_conv($hash{from_name});
	my $subject=&mime_conv($hash{subject});
	my $data=Jcode->new($hash{data})->jis;
	return 1 if($to eq '' || $from eq '' || $::modifier_sendmail eq '');
	$subject="[PW_H] $::basehref" if($subject eq '');

	$to=qq($to_name\n <$to>) if($to_name ne '');
	$from=qq($from_name\n <$from>) if($from_name ne '');
	my $mail=<<EOM;
To: $to
From: $from
Subject: $subject
MIME-Version: 1.0
Content-Type: text/plain; charset=ISO-2022-JP
Content-Transfer-Encoding: 7bit

$data
EOM

	foreach(split(/\n/,"$::modifier_sendmail\n$Nana::Mail::sendmail")) {
		my($exec,$opt1, $opt2, $opt3, $opt4, $opt5)=split(/ /,$_);
		if(-r $exec) {
			open(MAIL, "| $exec $opt1 $opt2 $opt3 $opt4 $opt5");
			print MAIL $mail;
			close(MAIL);
			return 0;
		}
	}
	return 1
}

sub toadmin {
	my($mode,$mail,$admin)=@_;
	&getremotehost;
	my $message = <<"EOD";
MODE = $mode
MAIL = $mail
REMOTE_ADDR = $ENV{REMOTE_ADDR}
REMOTE_HOST = $ENV{REMOTE_HOST}
EOD

	&send(to=>$admin, from=>$admin, 
		  subject=>"[PW_H]$mode $mail", data=>$message);
}

sub getremotehost {
	if($ENV{REMOTE_HOST} eq '') {
		my $host
		 = gethostbyaddr(pack("C4", split(/\./, $ENV{REMOTE_ADDR})), 2);
		if($host eq '') {
			$host=$ENV{REMOTE_ADDR};
		}
		$ENV{REMOTE_HOST}=$host;
	}
}

1;
NANA_MAIL

$fatpacked{"Nana/YukiWikiDB.pm"} = << 'NANA_YUKIWIKIDB';
package Nana::YukiWikiDB;
$VERSION="0.3p";
use strict;
use Nana::File;

# Constructor
sub new {
	return shift->TIEHASH(@_);
}

# tying
sub TIEHASH {
	my ($class, $dbname) = @_;
	my $self = {
		dir => $dbname,
		keys => [],
	};
	if (not -d $self->{dir}) {
		if (!mkdir($self->{dir}, 0777)) {
			return &die("mkdir $self->{dir} fail"); # debug
			return undef;
		}
	}
	return bless($self, $class);
}

# Store
sub STORE {
	my ($self, $key, $value) = @_;
	my $filename = &make_filename($self, $key);
	return Nana::File::lock_store($filename,$value);
}

# Fetch
sub FETCH {
	my ($self, $key) = @_;
	my $filename = &make_filename($self, $key);
	return Nana::File::lock_fetch($filename);
}

# Exists
sub EXISTS {
	my ($self, $key) = @_;
	my $filename = &make_filename($self, $key);
	return -e($filename);
}

# Delete
sub DELETE {
	my ($self, $key) = @_;
	my $filename = &make_filename($self, $key);
	return Nana::File::lock_delete($filename);
}

sub FIRSTKEY {
	my ($self) = @_;
	if(opendir(DIR, $self->{dir})) {
		@{$self->{keys}} = grep /\.txt$/, readdir(DIR);
		foreach my $name (@{$self->{keys}}) {
			$name =~ s/\.txt$//;
			$name =~ s/[0-9A-F][0-9A-F]/pack("C", hex($&))/eg;
		}
		closedir(DIR);
		return shift @{$self->{keys}};
	}
	return;
}

sub NEXTKEY {
	my ($self) = @_;
	return shift @{$self->{keys}};
}

sub make_filename {
	my ($self, $key) = @_;
	my $enkey;
	foreach my $ch (split(//, $key)) {
		$enkey .= sprintf("%02X", ord($ch));
	}
	return $self->{dir} . "/$enkey.txt";
}
1;
NANA_YUKIWIKIDB

$fatpacked{"Nana/Lock.pm"} = << 'NANA_LOCK';
package	Nana::Lock;
use 5.005;
use strict;
use vars qw($VERSION);
$VERSION = '0.2';

$Nana::Lock::LOCK_SH=1;
$Nana::Lock::LOCK_EX=2;
$Nana::Lock::LOCK_NB=4;
$Nana::Lock::LOCK_DELETE=128;

# rename lock idea
# http://www.din.or.jp/~ohzaki/perl.htm#File_Lock

sub lock {
	my $timeout=5;
	my $trytime=2;

	my($fname,$method)=@_;
	my($d,$f,$e)=$fname=~/(.*)\/(.+)\.(.+)$/;
	$f=~s/[.%()[]:*,_]//g;
	my %lfh=(
		dir=>$d,
		basename=>$f,
		timeout=>$timeout,
		trytime=>($method & $Nana::Lock::LOCK_NB ? 0 : $trytime),
		fname=>$fname,
		method=>$method & 3,
		path=>"$d/$f.lk"
	);
	if($method eq $Nana::Lock::LOCK_DELETE) {
		return &lock_del(%lfh);
	}
	return if($lfh{method} eq 0);

	for(my $i=0; $i < $lfh{trytime}*10; $i++) {
		$lfh{current}=sprintf("%s/%s.%x.%x.%x.%d.lk"
			,$lfh{dir},$lfh{basename},$lfh{method},$$,time);
		return \%lfh if(rename($lfh{path},$lfh{current}));

		my @filelist=&lock_getdir(%lfh);
		my @locklist=();
		my $fcount=0;
		my $excount=0;
		my $shcount=0;
		foreach (@filelist) {
			if (/^$lfh{basename}\.(\d)\.(.+)\.(.+)\.lk$/) {
				push(@locklist,"$1\t$2\t$3");
				$fcount++;
				$shcount++ if($1 eq 1);
				$excount++ if($1 eq 2);
			}
		}
		if($fcount eq 0) {
			open(LFHF,">$lfh{path}");# or return undef;
			close(LFHF);
			next;
		} elsif($lfh{method} eq 1) {
			if($shcount > 0 && $excount eq 0) {
				foreach(@locklist) {
					my($method,$pid,$time)=split(/\t/,$_);
					my $orgf=sprintf("%s/%s.%x.%s.%s.lk"
						,$lfh{dir},$lfh{basename},$method,$pid,$time);
					return \%lfh if(rename($orgf,$lfh{current}));
				}
			}
		}
		eval("select undef, undef, undef, 0.1;");
		if($@) {
			sleep 1;
			$i+=9;
		}
	}
	my @filelist=&lock_getdir(%lfh);
	foreach (@filelist) {
		if (/^$lfh{basename}\.(\d)\.(.+)\.(.+)\.lk$/) {
			if (time - hex($3) > $lfh{timeout}) {
				my $orgf=sprintf("%s/%s.%s.%s.%s.lk"
					,$lfh{dir},$lfh{basename},$1,$2,$3);
				return \%lfh if(rename($orgf,$lfh{current}));
			}
		}
	}
	return undef;
}

sub unlock {
	rename($_[0]->{current}, $_[0]->{path});
}

sub lock_del {
	my(%lfh)=@_;
	unlink($lfh{path});
	my @filelist=&lock_getdir(%lfh);
	foreach (@filelist) {
		if (/^$lfh{basename}\.(\d)\.(.+)\.(.+)\.lk$/) {
			unlink($_);
		}
	}
}

sub lock_getdir {
	my(%lfh)=@_;
	opendir(LOCKDIR, $lfh{dir});
	my @filelist = readdir(LOCKDIR);
	closedir(LOCKDIR);
	return @filelist;
}

1;
NANA_LOCK

$fatpacked{"Nana/File.pm"} = << 'NANA_FILE';
package	Nana::File;
use 5.005;
use strict;
use vars qw($VERSION);
$VERSION = '0.1';

use Fcntl ':flock';

$Nana::File::LOCK_SH=1;
$Nana::File::LOCK_EX=2;
$Nana::File::LOCK_NB=4;
$Nana::File::LOCK_DELETE=128;

$Nana::File::UseCache=1;

%Nana::File::_Cache=();

sub lock_store {
	my ($filename, $value) = @_;
	my $lfh;
	local $SIG{ALRM} = sub { die "time out" };

	if($Nana::File::UseCache eq 1) {
		$Nana::File::_Cache{$filename}=$value;
	}
	eval {
		if(open(FILE, "+<$filename") or open(FILE, ">$filename")) {
			alarm(5);
			eval("flock(FILE, LOCK_EX)");
			if ($@) {
				$lfh=&lock($filename,$Nana::File::LOCK_EX);
				if(!$lfh) {
					alarm(0);
					return undef;
				}
			}
			alarm(5);
			truncate(FILE, 0);
			# binmode(FILE);
			print FILE $value;
			alarm(5);
			eval("flock(FILE, LOCK_UN)");
			if ($@) {
				&unlock($lfh);
			}
			alarm(0);
			close(FILE);
		} else {
			alarm(0);
			return undef;
		}
		alarm(0);
	};
	if ($@ =~ /time out/) {
		return undef;
	}
	return $value;
}

sub lock_fetch {
	my ($filename) = @_;
	if($Nana::File::UseCache eq 1) {
		my $buf=$Nana::File::_Cache{$filename};
		return $buf if($buf ne '');
	}
	my $lfh;
	open(FILE, "$filename") or return(undef);
	eval("flock(FILE, LOCK_SH)");
	if ($@) {
		$lfh=&lock($filename,$Nana::File::LOCK_SH);
	}
	local $/;
	my $value = <FILE>;
	eval("flock(FILE, LOCK_UN)");
	if ($@) {
		&unlock($lfh);
	}
	close(FILE);
	if($Nana::File::UseCache eq 1) {
		$Nana::File::_Cache{$filename}=$value;
	}
	return $value;
}

sub lock_delete {
	my ($filename) = @_;

	my $lfh;
	open(FILE, "$filename") or return(undef);
	eval("flock(FILE, LOCK_SH)");
	if ($@) {
		$lfh=&lock($filename,$Nana::File::LOCK_DELETE);
	}
	eval("flock(FILE, LOCK_UN)");
	close(FILE);
	unlink($filename);
	if($Nana::File::UseCache eq 1) {
		$Nana::File::_Cache{$filename}='';
	}
}

sub lock {
	&load_module("Nana::Lock");
	return Nana::Lock::lock(@_);
}

sub unlock {
	&load_module("Nana::Lock");
	return Nana::Lock::unlock(@_);
}

sub load_module {
	my $funcp = $::functions{"load_module"};
	return &$funcp(@_);
}

1;
NANA_FILE

$fatpacked{"Nana/Cache.pm"} = << 'NANA_CACHE';
package	Nana::Cache;
use 5.005;
use strict;
use vars qw($VERSION);
$VERSION = '0.2';
use Nana::File;

sub new {
	my($class,%hash)=@_;
	my $self={
		ext=>$hash{ext},
		dir=>$hash{dir},
		files=>$hash{files},
		size=>$hash{size},
		use=>$hash{use},
		expire=>$hash{expire},
	};
	return bless $self, $class;
}

sub delete {
	my($self,$fname)=@_;
	my $f=sprintf("%s/%s.%s",$self->{dir},$fname,$self->{ext});
	unlink($f);
}

sub check {
	my $self=shift;
	my @chks=@_;
	my $tm;
	my $ext=$self->{ext};
	my $dir=$self->{dir};
	my $files=0;
	my $size=0;
	if(opendir(D,$dir)) {
		while(my $f=readdir(D)) {
			next if($f!~/\.$ext$/);
			my ($dev, $ino, $mode, $nlink, $uid, $gid, $rdev, $size,
				$atime, $mtime, $ctime, $blksize, $blocks) = stat("$dir/$f");
			$tm=$mtime if($tm<$mtime);
			$files++;
			$size+=$size;
		}
		closedir(D);
	}
	my $flg=0;
	foreach(@chks) {
		if((stat($_))[9] > $tm) {
			$flg=1;
			last;
		}
	}
	if($flg eq 1 || $files > $self->{files} || $size > $self->{size}) {
		if(opendir(D,$dir)) {
			while(my $f=readdir(D)) {
				next if($f!~/\.$ext$/);
				Nana::File::lock_delete("$dir/$f");
			}
			closedir(D);
		}
	}
}

sub expire {
	my($self,$fname,$expire)=@_;
	return 0 if($expire+0 eq 0);
	my $f=sprintf("%s/%s.%s",$self->{dir},$fname,$self->{ext});
#	if((stat($f))[8] + $expire+0 < time) {
	if((stat($f))[9] + $expire+0 < time) {
		Nana::File::lock_delete($f);
		return 1;
	}
	return 0;
}

sub read {
	my($self,$fname,$nodelete)=@_;
	return if($self->{use} ne 1);
	if($nodelete+0 ne 1) {
		return if(&expire($self,$fname,$self->{expire}));
	}
	my $buf;
	my $f=sprintf("%s/%s.%s",$self->{dir},$fname,$self->{ext});
	if(-r $f) {
		$buf=Nana::File::lock_fetch($f);
		return $buf;
	}
	return '';
}

sub write {
	my($self,$fname,$w)=@_;
	return if($self->{use} ne 1);
	my $f=sprintf("%s/%s.%s",$self->{dir},$fname,$self->{ext});
	return Nana::File::lock_store($f,$w);
}

sub hash_read {
	my($self,$fname,$nodelete)=@_;
	return if($self->{use} ne 1);
	if($nodelete+0 ne 1) {
		return if(&expire($self,$fname,$self->{expire}));
	}
	my %hash;
	my $f=sprintf("%s/%s.%s",$self->{dir},$fname,$self->{ext});
	if(-r $f) {
		my $buf=Nana::File::lock_fetch($f);
		$buf=~s/\x0D\x0A|\x0D|\x0A/\n/g;
		foreach(split(/\n/,$buf)) {
			chomp;
			my($buf1,$buf2)=split(/\t/,$_);
			$hash{$buf1}=$buf2;
		}
		return %hash;
	}
	return %hash;
}

sub hash_write {
	my($self,$fname,%hash)=@_;
	return if($self->{use} ne 1);
	my $f=sprintf("%s/%s.%s",$self->{dir},$fname,$self->{ext});
	my $buf;
	foreach(keys %hash) {
		$buf.="$_\t$hash{$_}\n";
	}
	return Nana::File::lock_store($f,$buf);
}
1;
NANA_CACHE

$fatpacked{"HTTP/Lite.pm"} = << 'HTTP_LITE';
package HTTP::Lite;

use 5.005;
use strict;
use Socket 1.3;
use Fcntl;
use Errno qw(EAGAIN);

use vars qw($VERSION);
BEGIN {
	$VERSION = "2.3";
}

my $BLOCKSIZE = 65536;
my $CRLF = "\r\n";
my $URLENCODE_VALID = "abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ0123456789_-.";

# Forward declarations
sub prepare_post;
sub http_write;
sub http_readline;
sub http_read;
sub http_readbytes;

# Prepare the urlencode validchars lookup hash
my @urlencode_valid;
foreach my $char (split('', $URLENCODE_VALID)) {
  $urlencode_valid[ord $char]=$char;
}
for (my $n=0;$n<255;$n++) {
  if (!defined($urlencode_valid[$n])) {
    $urlencode_valid[$n]=sprintf("%%%02X", $n);
  }
}

sub new 
{
  my $self = {};
  bless $self;
  $self->initialize();
  return $self;
}

sub initialize
{
  my $self = shift;
  $self->reset;
  $self->{timeout} = 120;
  $self->{HTTP11} = 0;
  $self->{DEBUG} = 0;
  $self->{header_at_once} = 0; 
  $self->{holdback} = 0;       # needed for http_write 
}

sub header_at_once
{
  my $self=shift;
  $self->{header_at_once} = 1;
}

sub local_addr
{
  my $self = shift;
  my $val = shift;
  my $oldval = $self->{'local_addr'};
  if (defined($val)) {
    $self->{'local_addr'} = $val;
  }
  return $oldval;
}

sub local_port
{
  my $self = shift;
  my $val = shift;
  my $oldval = $self->{'local_port'};
  if (defined($val)) {
    $self->{'local_port'} = $val;
   }
  return $oldval;
}

sub method
{
  my $self = shift;
  my $method = shift;
  $method = uc($method);
  $self->{method} = $method;
}

sub DEBUG
{
  my $self = shift;
  if ($self->{DEBUG}) {
    print STDERR join(" ", @_),"\n";
  }
}

sub reset
{
  my $self = shift;
  foreach my $var ("body", "request", "content", "status", "proxy",
    "proxyport", "resp-protocol", "error-message",  
    "resp-headers", "CBARGS", "callback_function", "callback_params")
  {
    $self->{$var} = undef;
  }
  $self->{HTTPReadBuffer} = "";
  $self->{method} = "GET";
  $self->{headers} = { 'user-agent' => "HTTP::Lite/$VERSION" };
  $self->{headermap} = { 'user-agent'  => 'User-Agent' };
}


# URL-encode data
sub escape {
  my $toencode = shift;
  return join('', 
    map { $urlencode_valid[ord $_] } split('', $toencode));
}

sub set_callback {
  my ($self, $callback, @callbackparams) = @_;
  $self->{'callback_function'} = $callback;
  $self->{'callback_params'} = [ @callbackparams ];
}

sub request
{
  my ($self, $url, $data_callback, $cbargs) = @_;
  
  my $method = $self->{method};
  if (defined($cbargs)) {
    $self->{CBARGS} = $cbargs;
  }

  my $callback_func = $self->{'callback_function'};
  my $callback_params = $self->{'callback_params'};

  # Parse URL 
  my ($protocol,$host,$junk,$port,$object) = 
    $url =~ m{^([^:/]+)://([^/:]*)(:(\d+))?(/.*)$};

  # Only HTTP is supported here
  if ($protocol ne "http")
  {
    warn "Only http is supported by HTTP::Lite";
    return undef;
  }
  
  # Setup the connection
  my $proto = getprotobyname('tcp');
  local *FH;
  socket(FH, PF_INET, SOCK_STREAM, $proto);
  $port = 80 if !$port;

  my $connecthost = $self->{'proxy'} || $host;
  $connecthost = $connecthost ? $connecthost : $host;
  my $connectport = $self->{'proxyport'} || $port;
  $connectport = $connectport ? $connectport : $port;
  my $addr = inet_aton($connecthost);
  if (!$addr) {
    close(FH);
    return undef;
  }
  if ($connecthost ne $host)
  {
    # if proxy active, use full URL as object to request
    $object = "$url";
  }

  # choose local port and address
  my $local_addr = INADDR_ANY; 
  my $local_port = "0";
  if (defined($self->{'local_addr'})) {
    $local_addr = $self->{'local_addr'};
    if ($local_addr eq "0.0.0.0" || $local_addr eq "0") {
      $local_addr = INADDR_ANY;
    } else {
      $local_addr = inet_aton($local_addr);
    }
  }
  if (defined($self->{'local_port'})) {
    $local_port = $self->{'local_port'};
  }
  my $paddr = pack_sockaddr_in($local_port, $local_addr); 
  bind(FH, $paddr) || return undef;  # Failing to bind is fatal.

  my $sin = sockaddr_in($connectport,$addr);
  connect(FH, $sin) || return undef;
  # Set nonblocking IO on the handle to allow timeouts
  if ( $^O ne "MSWin32" ) {
    fcntl(FH, F_SETFL, O_NONBLOCK);
  }

  if (defined($callback_func)) {
    &$callback_func($self, "connect", undef, @$callback_params);
  }  

  if ($self->{header_at_once}) {
    $self->{holdback} = 1;    # http_write should buffer only, no sending yet
  }

  # Start the request (HTTP/1.1 mode)
  if ($self->{HTTP11}) {
    $self->http_write(*FH, "$method $object HTTP/1.1$CRLF");
  } else {
    $self->http_write(*FH, "$method $object HTTP/1.0$CRLF");
  }

  # Add some required headers
  # we only support a single transaction per request in this version.
  $self->add_req_header("Connection", "close");    
  if ($port != 80) {
    $self->add_req_header("Host", "$host:$port");
  } else {
    $self->add_req_header("Host", $host);
  }
  if (!defined($self->get_req_header("Accept"))) {
    $self->add_req_header("Accept", "*/*");
  }

  if ($method eq 'POST') {
    $self->http_write(*FH, "Content-Type: application/x-www-form-urlencoded$CRLF");
  }
  
  # Purge a couple others
  $self->delete_req_header("Content-Type");
  $self->delete_req_header("Content-Length");
  
  # Output headers
  foreach my $header ($self->enum_req_headers())
  {
    my $value = $self->get_req_header($header);
    $self->http_write(*FH, $self->{headermap}{$header}.": ".$value."$CRLF");
  }
  
  my $content_length;
  if (defined($self->{content}))
  {
    $content_length = length($self->{content});
  }
  if (defined($callback_func)) {
    my $ncontent_length = &$callback_func($self, "content-length", undef, @$callback_params);
    if (defined($ncontent_length)) {
      $content_length = $ncontent_length;
    }
  }  

  if ($content_length) {
    $self->http_write(*FH, "Content-Length: $content_length$CRLF");
  }
  
  if (defined($callback_func)) {
    &$callback_func($self, "done-headers", undef, @$callback_params);
  }  
  # End of headers
  $self->http_write(*FH, "$CRLF");
  
  if ($self->{header_at_once}) {
    $self->{holdback} = 0; 
    $self->http_write(*FH, ""); # pseudocall to get http_write going
  }  
  
  my $content_out = 0;
  if (defined($callback_func)) {
    while (my $content = &$callback_func($self, "content", undef, @$callback_params)) {
      $self->http_write(*FH, $content);
      $content_out++;
    }
  } 
  
  # Output content, if any
  if (!$content_out && defined($self->{content}))
  {
    $self->http_write(*FH, $self->{content});
  }
  
  if (defined($callback_func)) {
    &$callback_func($self, "content-done", undef, @$callback_params);
  }  


  # Read response from server
  my $headmode=1;
  my $chunkmode=0;
  my $chunksize=0;
  my $chunklength=0;
  my $chunk;
  my $line = 0;
  my $data;
  while ($data = $self->http_read(*FH,$headmode,$chunkmode,$chunksize))
  {
    $self->{DEBUG} && $self->DEBUG("reading: $chunkmode, $chunksize, $chunklength, $headmode, ".
        length($self->{'body'}));
    if ($self->{DEBUG}) {
      foreach my $var ("body", "request", "content", "status", "proxy",
        "proxyport", "resp-protocol", "error-message", 
        "resp-headers", "CBARGS", "HTTPReadBuffer") 
      {
        $self->DEBUG("state $var ".length($self->{$var}));
      }
    }
    $line++;
    if ($line == 1)
    {
      my ($proto,$status,$message) = split(' ', $$data, 3);
      $self->{DEBUG} && $self->DEBUG("header $$data");
      $self->{status}=$status;
      $self->{'resp-protocol'}=$proto;
      $self->{'error-message'}=$message;
      next;
    } 
    if (($headmode || $chunkmode eq "entity-header") && $$data =~ /^[\r\n]*$/)
    {
      if ($chunkmode)
      {
        $chunkmode = 0;
      }
      $headmode = 0;
      
      # Check for Transfer-Encoding
      my $te = $self->get_header("Transfer-Encoding");
      if (defined($te)) {
        my $header = join(' ',@{$te});
        if ($header =~ /chunked/i)
        {
          $chunkmode = "chunksize";
        }
      }
      next;
    }
    if ($headmode || $chunkmode eq "entity-header")
    {
      my ($var,$datastr) = $$data =~ /^([^:]*):\s*(.*)$/;
      if (defined($var))
      {
        $datastr =~s/[\r\n]$//g;
        $var = lc($var);
        $var =~ s/^(.)/&upper($1)/ge;
        $var =~ s/(-.)/&upper($1)/ge;
        my $hr = ${$self->{'resp-headers'}}{$var};
        if (!ref($hr))
        {
          $hr = [ $datastr ];
        }
        else 
        {
          push @{ $hr }, $datastr;
        }
        ${$self->{'resp-headers'}}{$var} = $hr;
      }
    } elsif ($chunkmode)
    {
      if ($chunkmode eq "chunksize")
      {
        $chunksize = $$data;
        $chunksize =~ s/^\s*|;.*$//g;
        $chunksize =~ s/\s*$//g;
        my $cshx = $chunksize;
        if (length($chunksize) > 0) {
          # read another line
          if ($chunksize !~ /^[a-f0-9]+$/i) {
            $self->{DEBUG} && $self->DEBUG("chunksize not a hex string");
          }
          $chunksize = hex($chunksize);
          $self->{DEBUG} && $self->DEBUG("chunksize was $chunksize (HEX was $cshx)");
          if ($chunksize == 0)
          {
            $chunkmode = "entity-header";
          } else {
            $chunkmode = "chunk";
            $chunklength = 0;
          }
        } else {
          $self->{DEBUG} && $self->DEBUG("chunksize empty string, checking next line!");
        }
      } elsif ($chunkmode eq "chunk")
      {
        $chunk .= $$data;
        $chunklength += length($$data);
        if ($chunklength >= $chunksize)
        {
          $chunkmode = "chunksize";
          if ($chunklength > $chunksize)
          {
            $chunk = substr($chunk,0,$chunksize);
          } 
          elsif ($chunklength == $chunksize && $chunk !~ /$CRLF$/) 
          {
            # chunk data is exactly chunksize -- need CRLF still
            $chunkmode = "ignorecrlf";
          }
          $self->add_to_body(\$chunk, $data_callback);
          $chunk="";
          $chunklength = 0;
          $chunksize = "";
        } 
      } elsif ($chunkmode eq "ignorecrlf")
      {
        $chunkmode = "chunksize";
      }
    } else {
      $self->add_to_body($data, $data_callback);
    }
  }
  if (defined($callback_func)) {
    &$callback_func($self, "done", undef, @$callback_params);
  }
  close(FH);
  return $self->{status};
}

sub add_to_body
{
  my $self = shift;
  my ($dataref, $data_callback) = @_;
  
  my $callback_func = $self->{'callback_function'};
  my $callback_params = $self->{'callback_params'};

  if (!defined($data_callback) && !defined($callback_func)) {
    $self->{DEBUG} && $self->DEBUG("no callback");
    $self->{'body'}.=$$dataref;
  } else {
    my $newdata;
    if (defined($callback_func)) {
      $newdata = &$callback_func($self, "data", $dataref, @$callback_params);
    } else {
      $newdata = &$data_callback($self, $dataref, $self->{CBARGS});
    }
    if ($self->{DEBUG}) {
      $self->DEBUG("callback got back a ".ref($newdata));
      if (ref($newdata) eq "SCALAR") {
        $self->DEBUG("callback got back ".length($$newdata)." bytes");
      }
    }
    if (defined($newdata) && ref($newdata) eq "SCALAR") {
      $self->{'body'} .= $$newdata;
    }
  }
}

sub add_req_header
{
  my $self = shift;
  my ($header, $value) = @_;
  
  my $lcheader = lc($header);
  $self->{DEBUG} && $self->DEBUG("add_req_header $header $value");
  ${$self->{headers}}{$lcheader} = $value;
  ${$self->{headermap}}{$lcheader} = $header;
}

sub get_req_header
{
  my $self = shift;
  my ($header) = @_;
  
  return $self->{headers}{lc($header)};
}

sub delete_req_header
{
  my $self = shift;
  my ($header) = @_;
  
  my $exists;
  if ($exists=defined(${$self->{headers}}{lc($header)}))
  {
    delete ${$self->{headers}}{lc($header)};
    delete ${$self->{headermap}}{lc($header)};
  }
  return $exists;
}

sub enum_req_headers
{
  my $self = shift;
  my ($header) = @_;
  
  my $exists;
  return keys %{$self->{headermap}};
}

sub body
{
  my $self = shift;
  return $self->{'body'};
}

sub status
{
  my $self = shift;
  return $self->{status};
}

sub protocol
{
  my $self = shift;
  return $self->{'resp-protocol'};
}

sub status_message
{
  my $self = shift;
  return $self->{'error-message'};
}

sub proxy
{
  my $self = shift;
  my ($value) = @_;
  
  # Parse URL 
  my ($protocol,$host,$junk,$port,$object) = 
    $value =~ m{^(\S+)://([^/:]*)(:(\d+))?(/.*)$};
  if (!$host)
  {
    ($host,$port) = $value =~ /^([^:]+):(.*)$/;
  }

  $self->{'proxy'} = $host || $value;
  $self->{'proxyport'} = $port || 80;
}

sub headers_array
{
  my $self = shift;
  
  my @array = ();
  
  foreach my $header (keys %{$self->{'resp-headers'}})
  {
    my $aref = ${$self->{'resp-headers'}}{$header};
    foreach my $value (@$aref)
    {
      push @array, "$header: $value";
    }
  }
  return @array;
}

sub headers_string
{
  my $self = shift;
  
  my $string = "";
  
  foreach my $header (keys %{$self->{'resp-headers'}})
  {
    my $aref = ${$self->{'resp-headers'}}{$header};
    foreach my $value (@$aref)
    {
      $string .= "$header: $value\n";
    }
  }
  return $string;
}

sub get_header
{
  my $self = shift;
  my $header = shift;

  return $self->{'resp-headers'}{$header};
}

sub http11_mode
{
  my $self = shift;
  my $mode = shift;

  $self->{HTTP11} = $mode;
}

sub prepare_post
{
  my $self = shift;
  my $varref = shift;
  
  my $body = "";
  while (my ($var,$value) = map { escape($_) } each %$varref)
  {
    if ($body)
    {
      $body .= "&$var=$value";
    } else {
      $body = "$var=$value";
    }
  }
  $self->{content} = $body;
  $self->{headers}{'Content-Type'} = "application/x-www-form-urlencoded"
    unless defined ($self->{headers}{'Content-Type'}) and 
    $self->{headers}{'Content-Type'};
  $self->{method} = "POST";
}

sub http_write
{
  my $self = shift;
  my ($fh,$line) = @_;

  if ($self->{holdback}) {
     $self->{HTTPWriteBuffer} .= $line;
     return;
  } else {
     if (defined $self->{HTTPWriteBuffer}) {   # copy previously buffered, if any
         $line = $self->{HTTPWriteBuffer} . $line;
     }
  }

  my $size = length($line);
  my $bytes = syswrite($fh, $line, length($line) , 0 );  # please double check new length limit
                                                         # is this ok?
  while ( ($size - $bytes) > 0) {
    $bytes += syswrite($fh, $line, length($line)-$bytes, $bytes );  # also here
  }
}
 
sub http_read
{
  my $self = shift;
  my ($fh,$headmode,$chunkmode,$chunksize) = @_;

  $self->{DEBUG} && $self->DEBUG("read handle=$fh, headm=$headmode, chunkm=$chunkmode, chunksize=$chunksize");

  my $res;
  if (($headmode == 0 && $chunkmode eq "0") || ($chunkmode eq "chunk")) {
    my $bytes_to_read = $chunkmode eq "chunk" ?
        ($chunksize < $BLOCKSIZE ? $chunksize : $BLOCKSIZE) :
        $BLOCKSIZE;
    $res = $self->http_readbytes($fh,$self->{timeout},$bytes_to_read);
  } else { 
    $res = $self->http_readline($fh,$self->{timeout});  
  }
  if ($res) {
    if ($self->{DEBUG}) {
      $self->DEBUG("read got ".length($$res)." bytes");
      my $str = $$res;
      $str =~ s{([\x00-\x1F\x7F-\xFF])}{.}g;
      $self->DEBUG("read: ".$str);
    }
  }
  return $res;
}

sub http_readline
{
  my $self = shift;
  my ($fh, $timeout) = @_;
  my $EOL = "\n";

  $self->{DEBUG} && $self->DEBUG("readline handle=$fh, timeout=$timeout");
  
  # is there a line in the buffer yet?
  while ($self->{HTTPReadBuffer} !~ /$EOL/)
  {
    # nope -- wait for incoming data
    my ($inbuf,$bits,$chars) = ("","",0);
    vec($bits,fileno($fh),1)=1;
    my $nfound = select($bits, undef, $bits, $timeout);
    if ($nfound == 0)
    {
      # Timed out
      return undef;
    } else {
      # Get the data
      $chars = sysread($fh, $inbuf, $BLOCKSIZE);
      $self->{DEBUG} && $self->DEBUG("sysread $chars bytes");
    }
    # End of stream?
    if ($chars <= 0 && !$!{EAGAIN})
    {
      last;
    }
    # tag data onto end of buffer
    $self->{HTTPReadBuffer}.=$inbuf;
  }
  # get a single line from the buffer
  my $nlat = index($self->{HTTPReadBuffer}, $EOL);
  my $newline;
  my $oldline;
  if ($nlat > -1)
  {
    $newline = substr($self->{HTTPReadBuffer},0,$nlat+1);
    $oldline = substr($self->{HTTPReadBuffer},$nlat+1);
  } else {
    $newline = substr($self->{HTTPReadBuffer},0);
    $oldline = "";
  }
  # and update the buffer
  $self->{HTTPReadBuffer}=$oldline;
  return length($newline) ? \$newline : 0;
}

sub http_readbytes
{
  my $self = shift;
  my ($fh, $timeout, $bytes) = @_;
  my $EOL = "\n";

  $self->{DEBUG} && $self->DEBUG("readbytes handle=$fh, timeout=$timeout, bytes=$bytes");
  
  # is there enough data in the buffer yet?
  while (length($self->{HTTPReadBuffer}) < $bytes)
  {
    # nope -- wait for incoming data
    my ($inbuf,$bits,$chars) = ("","",0);
    vec($bits,fileno($fh),1)=1;
    my $nfound = select($bits, undef, $bits, $timeout);
    if ($nfound == 0)
    {
      # Timed out
      return undef;
    } else {
      # Get the data
      $chars = sysread($fh, $inbuf, $BLOCKSIZE);
      $self->{DEBUG} && $self->DEBUG("sysread $chars bytes");
    }
    # End of stream?
    if ($chars <= 0 && !$!{EAGAIN})
    {
      last;
    }
    # tag data onto end of buffer
    $self->{HTTPReadBuffer}.=$inbuf;
  }
  my $newline;
  my $buflen;
  if (($buflen=length($self->{HTTPReadBuffer})) >= $bytes)
  {
    $newline = substr($self->{HTTPReadBuffer},0,$bytes+1);
    if ($bytes+1 < $buflen) {
      $self->{HTTPReadBuffer} = substr($self->{HTTPReadBuffer},$bytes+1);
    } else {
      $self->{HTTPReadBuffer} = "";
    }
  } else {
    $newline = substr($self->{HTTPReadBuffer},0);
    $self->{HTTPReadBuffer} = "";
  }
  return length($newline) ? \$newline : 0;
}

sub upper
{
  my ($str) = @_;
  if (defined($str)) {
    return uc($str);
  } else {
    return undef;
  }
}

1;

__END__

=pod

=head1 NAME

HTTP::Lite - Lightweight HTTP implementation

=head1 SYNOPSIS

    use HTTP::Lite;
    $http = HTTP::Lite->new;
    $req = $http->request("http://www.cpan.org/") 
        or die "Unable to get document: $!";
    print $http->body();

=head1 DESCRIPTION

    HTTP::Lite is a stand-alone lightweight HTTP/1.1 implementation
    for perl.  It is not intended as a replacement for the
    fully-features LWP module.  Instead, it is intended for use in
    situations where it is desirable to install the minimal number of
    modules to achieve HTTP support, or where LWP is not a good
    candidate due to CPU overhead, such as slower processors.
    HTTP::Lite is also significantly faster than LWP.

    HTTP::Lite is ideal for CGI (or mod_perl) programs or for bundling
    for redistribution with larger packages where only HTTP GET and
    POST functionality are necessary.

    HTTP::Lite supports basic POST and GET operations only.  As of
    0.2.1, HTTP::Lite supports HTTP/1.1 and is compliant with the Host
    header, necessary for name based virtual hosting.  Additionally,
    HTTP::Lite now supports Proxies.

    As of 2.0.0 HTTP::Lite now supports a callback to allow processing
    of request data as it arrives.  This is useful for handling very
    large files without consuming memory.

    If you require more functionality, such as FTP or HTTPS, please
    see libwwwperl (LWP).  LWP is a significantly better and more
    comprehensive package than HTTP::Lite, and should be used instead
    of HTTP::Lite whenever possible.

=head1 CONSTRUCTOR

=over 4

=item new

This is the constructor for HTTP::Lite.  It presently takes no
arguments.  A future version of HTTP::Lite might accept parameters.

=back

=head1 METHODS

=over 4


=item request ( $url, $data_callback, $cbargs )

Initiates a request to the specified URL.

Returns undef if an I/O error is encountered, otherwise the HTTP
status code will be returned.  200 series status codes represent
success, 300 represent temporary errors, 400 represent permanent
errors, and 500 represent server errors.

See F<http://www.w3.org/Protocols/HTTP/HTRESP.html> for detailled
information about HTTP status codes.

The $data_callback parameter, if used, is a way to filter the data as it is
received or to handle large transfers.  It must be a function reference, and
will be passed: a reference to the instance of the http request making the
callback, a reference to the current block of data about to be added to the
body, and the $cbargs parameter (which may be anything).  It must return
either a reference to the data to add to the body of the document, or undef.

If set_callback is used, $data_callback and $cbargs are not used.  $cbargs
may be either a scalar or a reference.

The data_callback is called as: 
  &$data_callback( $self, $dataref, $cbargs )

An example use to save a document to file is:

  # Write the data to the filehandle $cbargs
  sub savetofile {
    my ($self,$phase,$dataref,$cbargs) = @_;
    print $cbargs $$dataref;
    return undef;
  }

  $url = "$testpath/bigbinary.dat";
  open OUT, '>','bigbinary.dat';
  $res = $http->request($url, \&savetofile, OUT);
  close OUT;

=item set_callback ( $functionref, $dataref )

At various stages of the request, callbacks may be used to modify the
behaviour or to monitor the status of the request.  These work like the
$data_callback parameter to request(), but are more verstaile.  Using
set_callback disables $data_callback in request()

The callbacks are called as: 
  callback ( $self, $phase, $dataref, $cbargs )

The current phases are:

  connect - connection has been established and headers are being
            transmitted.

  content-length - return value is used as the content-length.  If undef,
            and prepare_post() was used, the content length is
            calculated.

  done-headers - all headers have been sent

  content - return value is used as content and is sent to client.  Return
            undef to use the internal content defined by prepare_post().

  content-done - content has been successfuly transmitted.

  data - A block of data has been received.  The data is referenced by
            $dataref.  The return value is dereferenced and replaces the
            content passed in.  Return undef to avoid using memory for large
            documents.

  done - Request is done.



=item prepare_post ( $hashref )

Takes a reference to a hashed array of post form variables to upload. 
Create the HTTP body and sets the method to POST.

=item http11_mode ( 0 | 1 )

Turns on or off HTTP/1.1 support.  This is off by default due to
broken HTTP/1.1 servers.  Use 1 to enable HTTP/1.1 support.

=item add_req_header ( $header, $value )

=item get_req_header ( $header )

=item delete_req_header ( $header )

Add, Delete, or a HTTP header(s) for the request.  These functions
allow you to override any header.  Presently, Host, User-Agent,
Content-Type, Accept, and Connection are pre-defined by the HTTP::Lite
module.  You may not override Host, Connection, or Accept.

To provide (proxy) authentication or authorization, you would use:

    use HTTP::Lite;
    use MIME::Base64;
    $http = HTTP::Lite->new;
    $encoded = encode_base64('username:password');
    $http->add_req_header("Authorization", $encoded);

B<NOTE>: The present implementation limits you to one instance
of each header.

=item body

Returns the body of the document retured by the remote server.

=item headers_array

Returns an array of the HTTP headers returned by the remote
server.

=item headers_string

Returns a string representation of the HTTP headers returned by
the remote server.

=item get_header ( $header )

Returns an array of values for the requested header.  

B<NOTE>: HTTP requests are not limited to a single instance of
each header.  As a result, there may be more than one entry for
every header.

=item protocol

Returns the HTTP protocol identifier, as reported by the remote
server.  This will generally be either HTTP/1.0 or HTTP/1.1.

=item proxy ( $proxy_server )

The URL or hostname of the proxy to use for the next request.

=item status

Returns the HTTP status code returned by the server.  This is
also reported as the return value of I<request()>.

=item status_message

Returns the textual description of the status code as returned
by the server.  The status string is not required to adhere to
any particular format, although most HTTP servers use a standard
set of descriptions.

=item reset

You must call this prior to re-using an HTTP::Lite handle,
otherwise the results are undefined.

=item local_addr ( $ip )

Explicity select the local IP address.  0.0.0.0 (default) lets the system
choose.

=item local_port ( $port )

Explicity select the local port.  0 (default and recommended) lets the
system choose.

=item method ( $method )

Explicity set the method.  Using prepare_post or reset overrides this
setting.  Usual choices are GET, POST, PUT, HEAD

=back

=head1 EXAMPLES

    # Get and print out the headers and body of the CPAN homepage
    use HTTP::Lite;
    $http = HTTP::Lite->new;
    $req = $http->request("http://www.cpan.org/")
        or die "Unable to get document: $!";
    die "Request failed ($req): ".$http->status_message()
      if $req ne "200";
    @headers = $http->headers_array();
    $body = $http->body();
    foreach $header (@headers)
    {
      print "$header$CRLF";
    }
    print "$CRLF";
    print "$body$CRLF";

    # POST a query to the dejanews USENET search engine
    use HTTP::Lite;
    $http = HTTP::Lite->new;
    %vars = (
             "QRY" => "perl",
             "ST" => "MS",
             "svcclass" => "dncurrent",
             "DBS" => "2"
            );
    $http->prepare_post(\%vars);
    $req = $http->request("http://www.deja.com/dnquery.xp")
      or die "Unable to get document: $!";
    print "req: $req\n";
    print $http->body();

=head1 UNIMPLEMENTED

    - FTP 
    - HTTPS (SSL)
    - Authenitcation/Authorizaton/Proxy-Authorization
      are not directly supported, and require MIME::Base64.
    - Redirects (Location) are not automatically followed
    - multipart/form-data POSTs are not directly supported (necessary
      for File uploads).

=head1 BUGS

    Some broken HTTP/1.1 servers send incorrect chunk sizes
    when transferring files.  HTTP/1.1 mode is now disabled by
    default.

=head1 AUTHOR

Roy Hooper <rhooper@thetoybox.org>

=head1 SEE ALSO

L<LWP>
RFC 2068 - HTTP/1.1 -http://www.w3.org/

=head1 COPYRIGHT

Copyright (c) 2000-2002 Roy Hooper.  All rights reserved.

Some parts copyright 2009 - 2010 Adam Kennedy.

This program is free software; you can redistribute it and/or modify it
under the same terms as Perl itself.

=cut
HTTP_LITE

$fatpacked{"Text/MicroTemplate.pm"} = <<'TEXT_MICROTEMPLATE';
  # modified for NanoA by kazuho, some modified by tokuhirom
  # based on Mojo::Template. Copyright (C) 2008, Sebastian Riedel.
  
  package Text::MicroTemplate;
  
  require Exporter;
  
  use strict;
  use warnings;
  use constant DEBUG => $ENV{MICRO_TEMPLATE_DEBUG} || 0;
  use 5.00800;
  
  use Carp 'croak';
  use Scalar::Util;
  
  our $VERSION = '0.18';
  our @ISA = qw(Exporter);
  our @EXPORT_OK = qw(encoded_string build_mt render_mt);
  our %EXPORT_TAGS = (
      all => [ @EXPORT_OK ],
  );
  our $_mt_setter = '';
  
  sub new {
      my $class = shift;
      my $self = bless {
          code                => undef,
          comment_mark        => '#',
          expression_mark     => '=',
          line_start          => '?',
          template            => undef,
          tree                => [],
          tag_start           => '<?',
          tag_end             => '?>',
          escape_func         => \&_inline_escape_html,
          package_name        => undef, # defaults to caller
          @_ == 1 ? ref($_[0]) ? %{$_[0]} : (template => $_[0]) : @_,
      }, $class;
      if (defined $self->{template}) {
          $self->parse($self->{template});
      }
      unless (defined $self->{package_name}) {
          $self->{package_name} = 'main';
          my $i = 0;
          while (my $c = caller(++$i)) {
              if ($c !~ /^Text::MicroTemplate\b/) {
                  $self->{package_name} = $c;
                  last;
              }
          }
      }
      $self;
  }
  
  sub escape_func {
      my $self = shift;
      if (@_) {
          $self->{escape_func} = shift;
      }
      $self->{escape_func};
  }
  
  sub package_name {
      my $self = shift;
      if (@_) {
          $self->{package_name} = shift;
      }
      $self->{package_name};
  }
  
  sub template { shift->{template} }
  
  sub code {
      my $self = shift;
      unless (defined $self->{code}) {
          $self->_build();
      }
      $self->{code};
  }
  
  sub _build {
      my $self = shift;
      
      my $escape_func = $self->{escape_func} || '';
  
      my $embed_escape_func = ref($escape_func) eq 'CODE'
          ? $escape_func
          : sub{ $escape_func . "(@_)" };
  
      # Compile
      my @lines;
      my $last_was_code;
      my $last_text;
      for my $line (@{$self->{tree}}) {
  
          # New line
          push @lines, '';
          for (my $j = 0; $j < @{$line}; $j += 2) {
              my $type  = $line->[$j];
              my $value = $line->[$j + 1];
  
              if ($type ne 'text' && defined $last_text) {
                  # do not mess the start of current line, since it might be
                  # the start of "=pod", etc.
                  $lines[
                      $j == 0 && @lines >= 2 ? -2 : -1
                  ] .= "\$_MT .=\"$last_text\";";
                  undef $last_text;
              }
              
              # Need to fix line ending?
              my $newline = chomp $value;
  
              # add semicolon to last line of code
              if ($last_was_code && $type ne 'code') {
                  $lines[-1] .= ';';
                  undef $last_was_code;
              }
  
              # Text
              if ($type eq 'text') {
  
                  # Quote and fix line ending
                  $value = quotemeta($value);
                  $value .= '\n' if $newline;
  
                  $last_text = defined $last_text ? "$last_text$value" : $value;
              }
  
              # Code
              if ($type eq 'code') {
                  $lines[-1] .= $value;
                  $last_was_code = 1;
              }
  
              # Expression
              if ($type eq 'expr') {
                  my $escaped = $embed_escape_func->('$_MT_T');
                  $lines[-1] .= "\$_MT_T = $value;\$_MT .= ref \$_MT_T eq 'Text::MicroTemplate::EncodedString' ? \$\$_MT_T : $escaped;";
              }
          }
      }
  
      # add semicolon to last line of code
      if ($last_was_code) {
          $lines[-1] .= "\n;";
      }
      # add last text line(s)
      if (defined $last_text) {
          $lines[-1] .= "\$_MT .=\"$last_text\";";
      }
      
      # Wrap
      $lines[0]   = q/sub { my $_MT = ''; local $/ . $self->{package_name} . q/::_MTREF = \$_MT; my $_MT_T = '';/ . (@lines ? $lines[0] : '');
      $lines[-1] .= q/return $_MT; }/;
  
      $self->{code} = join "\n", @lines;
      return $self;
  }
  
  # I am so smart! I am so smart! S-M-R-T! I mean S-M-A-R-T...
  sub parse {
      my ($self, $tmpl) = @_;
      $self->{template} = $tmpl;
  
      # Clean start
      delete $self->{tree};
      delete $self->{code};
  
      # Tags
      my $line_start    = quotemeta $self->{line_start};
      my $tag_start     = quotemeta $self->{tag_start};
      my $tag_end       = quotemeta $self->{tag_end};
      my $cmnt_mark     = quotemeta $self->{comment_mark};
      my $expr_mark     = quotemeta $self->{expression_mark};
  
      # Tokenize
      my $state = 'text';
      my $multiline_expression = 0;
      my @lines = split /(\n)/, $tmpl;
      while (@lines) {
          my $line = shift @lines;
          my $newline = undef;
          if (@lines) {
              shift @lines;
              $newline = 1;
          }
          
          # Perl line without return value
          if ($line =~ /^$line_start\s+(.*)$/) {
              push @{$self->{tree}}, ['code', $1];
              $multiline_expression = 0;
              next;
          }
  
          # Perl line with return value
          if ($line =~ /^$line_start$expr_mark\s+(.+)$/) {
              push @{$self->{tree}}, [
                  'expr', $1,
                  $newline ? ('text', "\n") : (),
              ];
              $multiline_expression = 0;
              next;
          }
  
          # Comment line, dummy token needed for line count
          if ($line =~ /^$line_start$cmnt_mark\s+$/) {
              push @{$self->{tree}}, [];
              $multiline_expression = 0;
              next;
          }
  
          # Escaped line ending?
          if ($line =~ /(\\+)$/) {
              my $length = length $1;
  
              # Newline escaped
              if ($length == 1) {
                  $line =~ s/\\$//;
              }
  
              # Backslash escaped
              if ($length >= 2) {
                  $line =~ s/\\\\$/\\/;
                  $line .= "\n";
              }
          }
  
          # Normal line ending
          else { $line .= "\n" if $newline }
  
          # Mixed line
          my @token;
          for my $token (split /
              (
                  $tag_start$expr_mark     # Expression
              |
                  $tag_start$cmnt_mark     # Comment
              |
                  $tag_start               # Code
              |
                  $tag_end                 # End
              )
          /x, $line) {
  
              # Garbage
              next if $token eq '';
  
              # End
              if ($token =~ /^$tag_end$/) {
                  $state = 'text';
                  $multiline_expression = 0;
              }
  
              # Code
              elsif ($token =~ /^$tag_start$/) { $state = 'code' }
  
              # Comment
              elsif ($token =~ /^$tag_start$cmnt_mark$/) { $state = 'cmnt' }
  
              # Expression
              elsif ($token =~ /^$tag_start$expr_mark$/) {
                  $state = 'expr';
              }
  
              # Value
              else {
  
                  # Comments are ignored
                  next if $state eq 'cmnt';
  
                  # Multiline expressions are a bit complicated,
                  # only the first line can be compiled as 'expr'
                  $state = 'code' if $multiline_expression;
                  $multiline_expression = 1
                      if $state eq 'expr';
  
                  # Store value
                  push @token, $state, $token;
              }
          }
          push @{$self->{tree}}, \@token;
      }
      
      return $self;
  }
  
  sub _context {
      my ($self, $text, $line) = @_;
      my @lines  = split /\n/, $text;
      
      join '', map {
          0 < $_ && $_ <= @lines ? sprintf("%4d: %s\n", $_, $lines[$_ - 1]) : ''
      } ($line - 2) .. ($line + 2);
  }
  
  # Debug goodness
  sub _error {
      my ($self, $error, $line_offset, $from) = @_;
      
      # Line
      if ($error =~ /^(.*)\s+at\s+\(eval\s+\d+\)\s+line\s+(\d+)/) {
          my $reason = $1;
          my $line   = $2 - $line_offset;
          my $delim  = '-' x 76;
          
          my $report = "$reason at line $line in template passed from $from.\n";
          my $template = $self->_context($self->{template}, $line);
          $report .= "$delim\n$template$delim\n";
  
          # Advanced debugging
          if (DEBUG) {
              my $code = $self->_context($self->code, $line);
              $report .= "$code$delim\n";
              $report .= $error;
          }
  
          return $report;
      }
  
      # No line found
      return "Template error: $error";
  }
  
  # create raw string (that does not need to be escaped)
  sub encoded_string {
      Text::MicroTemplate::EncodedString->new($_[0]);
  }
  
  
  sub _inline_escape_html{
      my($variable) = @_;
  
      my $source = qq{
          do{
              $variable =~ s/([&><"'])/\$Text::MicroTemplate::_escape_table{\$1}/ge;
              $variable;
          }
      }; #" for poor editors
      $source =~ s/\n//g; # to keep line numbers
      return $source;
  }
  
  our %_escape_table = ( '&' => '&amp;', '>' => '&gt;', '<' => '&lt;', q{"} => '&quot;', q{'} => '&#39;' );
  sub escape_html {
      my $str = shift;
      return ''
          unless defined $str;
      return $str->as_string
          if ref $str eq 'Text::MicroTemplate::EncodedString';
      $str =~ s/([&><"'])/$_escape_table{$1}/ge; #' for poor editors
      return $str;
  }
  
  sub build_mt {
      my $mt = Text::MicroTemplate->new(@_);
      $mt->build();
  }
  
  sub build {
      my $_mt = shift;
      Scalar::Util::weaken($_mt) if $_mt_setter;
      my $_code = $_mt->code;
      my $_from = sub {
          my $i = 0;
          while (my @c = caller(++$i)) {
              return "$c[1] at line $c[2]"
                  if $c[0] ne __PACKAGE__;
          }
          '';
      }->();
      my $expr = << "...";
  package $_mt->{package_name};
  sub {
      ${_mt_setter}local \$SIG{__WARN__} = sub { print STDERR \$_mt->_error(shift, 4, \$_from) };
      Text::MicroTemplate::encoded_string((
          $_code
      )->(\@_));
  }
  ...
  
      if(DEBUG >= 2){
          DEBUG >= 3 ? die $expr : warn $expr;
      }
  
      my $die_msg;
      {
          local $@;
          if (my $_builder = eval($expr)) {
              return $_builder;
          }
          $die_msg = $_mt->_error($@, 4, $_from);
      }
      die $die_msg;
  }
  
  sub render_mt {
      my $builder = build_mt(shift);
      $builder->(@_);
  }
  
  # ? $_mt->filter(sub { s/\s+//smg; s/[\r\n]//g; })->(sub { ... ? });
  sub filter {
      my ($self, $callback) = @_;
      my $mtref = do {
          no strict 'refs';
          ${"$self->{package_name}::_MTREF"};
      };
      my $before = $$mtref;
      $$mtref = '';
      return sub {
          my $inner_func = shift;
          $inner_func->(@_);
  
          ## sub { s/foo/bar/g } is a valid filter
          ## sub { DateTime::Format::Foo->parse_string(shift) } is valid too
          local $_ = $$mtref;
          my $retval = $callback->($$mtref);
          no warnings 'uninitialized';
          if (($retval =~ /^\d+$/ and $_ ne $$mtref) or (defined $retval and !$retval)) {
              $$mtref = $before . $_;
          } else {
              $$mtref = $before . $retval;
          }
      }
  }
  
  package Text::MicroTemplate::EncodedString;
  
  use strict;
  use warnings;
  
  use overload q{""} => sub { shift->as_string }, fallback => 1;
  
  sub new {
      my ($klass, $str) = @_;
      bless \$str, $klass;
  }
  
  sub as_string {
      my $self = shift;
      $$self;
  }
  
  1;
  __END__
  
  =head1 NAME
  
  Text::MicroTemplate - Micro template engine with Perl5 language
  
  =head1 SYNOPSIS
  
      use Text::MicroTemplate qw(:all);
  
      # compile template, and render
      $renderer = build_mt('hello, <?= $_[0] ?>');
      $html = $renderer->('John')->as_string;
  
      # or in one line
      $html = render_mt('hello, <?= $_[0] ?>', 'John')->as_string;
  
      # complex form
      $mt = Text::MicroTemplate->new(
          template => 'hello, <?= $query->param('user') ?>',
      );
      $code = $mt->code;
      $renderer = eval << "..." or die $@;
      sub {
          my \$query = shift;
          $code->();
      }
      ...
      $html = $renderer->(CGI->new)->as_string;
  
  =head1 DESCRIPTION
  
  Text::MicroTemplate is a standalone, fast, intelligent, extensible template engine with following features.
  
  =head2 standalone
  
  Text::MicroTemplate does not rely on other CPAN modules.
  
  =head2 fast
  
  Based on L<Mojo::Template>, expressions in the template is perl code.
  
  =head2 intelligent
  
  Text::MicroTemplate automatically escapes variables when and only when necessary.
  
  =head2 extensible
  
  Text::MicroTemplate does not provide features like template cache or including other files by itself.  However, it is easy to add you own (that suites the most to your application), by wrapping the result of the module (which is a perl expression).
  
  The module only provides basic building blocks for a template engine.  Refer to L<Text::MicroTemplate::File> for higher-level interface.
  
  =head1 TEMPLATE SYNTAX
  
  The template language is Perl5 itself!
  
      # output the result of expression with automatic escape
      <?= $expr ?>             (tag style)
      ?= $expr                 (per-line)
  
      # execute perl code (tag style)
      <? foo() ?>
      ? foo()
  
      # comment (tag style)
      <?# comment ?>
      ?# comment
  
      # loops
      <ul>
      ? for my $item (@list) {
      <li><?= $item ?></li>
      ? }
      </ul>
  
  =head1 EXPORTABLE FUNCTIONS
  
  =head2 build_mt($template)
  
  Returns a subref that renders given template.  Parameters are equivalent to Text::MicroTemplate->new.
  
      # build template renderer at startup time and use it multiple times
      my $renderer = build_mt('hello, <?= $_[0] ?>!');
  
      sub run {
          ...
          my $hello = $renderer->($query->param('user'));
          ...
      }
  
  =head2 render_mt($template, @args)
  
  Utility function that combines build_mt and call to the generated template builder.
  
      # render
      $hello = render_mt('hello, <?= $_[0] ?>!', 'John');
  
      # print as HTML
      print $hello->as_string;
  
      # use the result in another template (no double-escapes)
      $enc = render_mt('<h1><?= $_[0] ?></h1>', $hello);
  
  Intertally, the function is equivalent to:
  
      build_mt($template)->(@_);
  
  =head2 encoded_string($str)
  
  wraps given string to an object that will not be escaped by the template engine
  
  =head1 OO-STYLE INTERFACE
  
  Text::MicroTemplate provides OO-style interface to handle more complex cases.
  
  =head2 new($template)
  
  =head2 new(%args)
  
  =head2 new(\%args)
  
  Constructs template renderer.  In the second or third form, parameters below are recognized.
  
  =head3 template
  
  template string (mandatory)
  
  =head3 escape_func
  
  escape function (defaults to L<Text::MicroTemplate::escape_html>), no escape when set to undef
  
  =head3 package_name
  
  package under where the renderer is compiled (defaults to caller package)
  
  =head2 code()
  
  returns perl code that renders the template when evaluated
  
  =head2 filter(sub filter_func { ... })->(sub { template lines })
  
  filters given template lines
  
      ? $_mt->filter(sub { s/Hello/Good bye/g })->(sub {
      Hello, John!
      ? })
  
  =head1 DEBUG
  
  The C<MICRO_TEMPLATE_DEBUG> environment variable helps debugging.
  The value C<1> extends debugging messages, C<2> reports compiled
  Perl code with C<warn()>, C<3> is like C<2> but uses C<die()>.
  
  =head1 SEE ALSO
  
  L<Text::MicroTemplate::File>
  
  L<Text::MicroTemplate::Extended>
  
  =head1 AUTHOR
  
  Kazuho Oku E<lt>kazuhooku gmail.comE<gt>
  
  Tokuhiro Matsuno E<lt>tokuhirom AAJKLFJEF GMAIL COME<gt>
  
  The module is based on L<Mojo::Template> by Sebastian Riedel.
  
  =head1 LICENSE
  
  This program is free software, you can redistribute it and/or modify it under the same terms as Perl itself.
  
  =cut
TEXT_MICROTEMPLATE

$fatpacked{"Text/MicroTemplate/EncodedString.pm"} = <<'TEXT_MICROTEMPLATE_ENCODEDSTRING';
  # the package in implemented intentionally in Text::MicroTemplate
  use Text::MicroTemplate;
  1;
TEXT_MICROTEMPLATE_ENCODEDSTRING

$fatpacked{"Text/MicroTemplate/File.pm"} = <<'TEXT_MICROTEMPLATE_FILE';
  package Text::MicroTemplate::File;
  
  use strict;
  use warnings;
  use File::Spec;
  use Text::MicroTemplate;
  
  use Carp qw(croak);
  
  our @ISA = qw(Text::MicroTemplate);
  
  sub new {
      my $klass = shift;
      my $self = $klass->SUPER::new(@_);
      $self->{include_path} ||= [ '.' ];
      unless (defined $self->{open_layer}) {
          $self->{open_layer} = ':utf8';
      }
      unless (ref $self->{include_path}) {
          $self->{include_path} = [ $self->{include_path} ];
      }
      $self->{use_cache} ||= 0;
      $self->{cache} = {};  # file => { mtime, sub }
      $self;
  }
  
  sub include_path {
      my $self = shift;
      croak "This is readonly accessor" if @_;
      $self->{include_path};
  }
  
  sub open_layer {
      my $self = shift;
      $self->{open_layer} = $_[0]
          if @_;
      $self->{open_layer};
  }
  
  sub use_cache {
      my $self = shift;
      $self->{use_cache} = $_[0]
          if @_;
      $self->{use_cache};
  }
  
  sub build_file {
      my ($self, $file) = @_;
      # return cached entry
      if ($self->{use_cache} == 2) {
          if (my $e = $self->{cache}->{$file}) {
              return $e->[1];
          }
      }
      # setup ($filepath, @st)
      my ($filepath, @st);
      if (File::Spec->file_name_is_absolute($file)) {
          # absolute path
          $filepath = $file;
          @st = stat $filepath;
      } else {
          # relative path, search "include_path"s
          foreach my $path (@{$self->{include_path}}) {
              $filepath = $path . '/' . $file;
              @st = stat $filepath
                  and last;
          }
      }
      croak "could not find template file: $file (include_path: @{$self->{include_path}})"
          unless @st;
      
      # return cached entry after comparing mtime
      if (my $e = $self->{cache}->{$file}) {
          return $e->[1]
              if $st[9] == $e->[0]; # compare mtime
      }
  
      # read the file, parse, build, cache the entry if necessary, and return
      open my $fh, "<$self->{open_layer}", $filepath
          or croak "failed to open:$filepath:$!";
      my $src = do { local $/; <$fh> };
      close $fh;
      $self->parse($src);
      local $Text::MicroTemplate::_mt_setter = 'my $_mt = shift;';
      my $f = $self->build();
      $self->{cache}->{$file} = [
          $st[9], # mtime
          $f,
      ] if $self->{use_cache};
      return $f;
  }
  
  sub render_file {
      my $self = shift;
      my $file = shift;
      $self->build_file($file)->($self, @_);
  }
  
  sub wrapper_file {
      my $self = shift;
      my $file = shift;
      my @args = @_;
      my $mtref = do {
          no strict 'refs';
          ${"$self->{package_name}::_MTREF"};
      };
      my $before = $$mtref;
      $$mtref = '';
      return sub {
          my $inner_func = shift;
          $inner_func->(@_);
          $$mtref =
              $before . $self->render_file($file, Text::MicroTemplate::encoded_string($$mtref), @args)->as_string;
      }
  }
  
  1;
  __END__
  
  =head1 NAME
  
  Text::MicroTemplate::File - a file-based template manager
  
  =head1 SYNOPSIS
  
      use Text::MicroTemplate::File;
  
      our $mtf = Text::MicroTemplate::File->new(
          include_path => [ $path1, $path2, ... ],
          use_cache    => 1,
      );
  
      # render
      $mtf->render_file('template.file', $arg1, $arg2, ...);
  
  =head1 DESCRIPTION
  
  Text::MicroTemplate::File is a file-based template manager for L<Text::MicroTemplate>.
  
  =head1 PROPERTIES
  
  Text::MicroTemplate provides OO-style interface with following properties.
  
  =head2 include_path
  
  include path (default: ['.'])
  
  This accessor is readonly.
  
  =head2 use_cache
  
  cache mode (0: no cache (default), 1: cache with update check, 2: cache but do not check updates)
  
  =head2 open_layer
  
  layer passed to L<open> (default: ":utf8")
  
  =head2 package_name
  
  package under where template files are compiled (default: "main")
  
  =head1 METHODS
  
  =head2 build_file($file)
  
  Returns a subref that renders given template file.
  
  =head2 render_file($file, @args)
  
  Renders the template file with given arguments.
  
  =head2 wrapper_file($file, @args)->(sub { template lines })
  
  Wraps given template with wrapper file.  Internally the processed template is passed as $_[0] to the wrapper template.
  
  =head1 SEE ALSO
  
  L<Text::MicroTemplate>
  
  =head1 AUTHOR
  
  Kazuho Oku E<lt>kazuhooku gmail.comE<gt>
  
  =head1 LICENSE
  
  This program is free software, you can redistribute it and/or modify it under the same terms as Perl 5.10.
  
  =cut
TEXT_MICROTEMPLATE_FILE

s/^  //mg for values %fatpacked;

unshift @INC, sub {
  if (my $fat = $fatpacked{$_[1]}) {
    open my $fh, '<', \$fat
      or die "FatPacker error loading $_[1] (could be a perl installation issue?)";
    return $fh;
  }
  return
};

} # END OF FATPACK CODE
1;
