#!/usr/bin/perl

# 東京電力、電力見通し取得スクリプト（旧スクリプト）

BEGIN {
	chdir("/home/ymda/htdocs/denki");
	chdir("/home/ymda/00www/denkiyohou/htdocs");
	require "fatlib.pl";
}

exit;

require "common.pl";

use utf8;
use strict;
use HTTP::Lite;
use Jcode;
my $tepco_mitoushi_url="http://www.tepco.co.jp/forecast/mitoushi-j.csv";
my $cachefile="./cache/mitoushi.csv";
my $writefilelist=".write_mitoushi_files";
my $http=new HTTP::Lite;
$http->method("GET");
$http->http11_mode(1);
$http->add_req_header("User-Agent","denkiyohou (http://denkiyohou.daiba.cx/)");
my $loop=1;
my $body;
while($loop) {
	my $req=$http->request($tepco_mitoushi_url);
	if($req eq 200) {
		$body=$http->body();
		$loop=0;
	} else {
		sleep 1;
	}
}
$body=~s/\x0D\x0A|\x0D|\x0A/\x0A/g;

if(open(W,">$cachefile")) {
	print W Jcode->new($body)->utf8;
	close(W);
}

my $date;
my $tmp;
my $maxpower;
my $juyou;
my $time1;
my $time2;
my $update;
my $persent;
my $text;
my $html;
my $xml;
my $mhtml;
my $rssdate;

if(open(R,"<:utf8","$cachefile")) {
	# １行目 日付
	$tmp=<R>;
	$tmp=~s/\n//g;
	$tmp=~s/（/［/g;
	$tmp=~s/）/]/g;
	$tmp=~s/【//g;
	$tmp=~s/】//g;
	$tmp=~s/\,//g;
	$tmp=~s/(\d+)\/(\d+)\/(\d+)［(.+)].*/$1年$2月$3日\($4\)/;
	$date=$tmp;
	# ２行目　スキップ
	$tmp=<R>;

	# ３行目 ピーク時供給力
	# ピーク時供給力(万kW),時間帯(自）,時間帯（至）,供給力情報更新日,供給力情報更新時刻
	$tmp=<R>;
	$tmp=~s/\n//g;
	if($tmp=~/^\"(.+)\"\,(.+)\:(.+)\,(.+)\:(.+)\,(.+)\/(.+)\,(.+)\:(.+)/) {
		$maxpower=$1;
		$update="$6月$7日 $8時$9分";
		$rssdate=sprintf("%04d-%02d-%02dT%02d:%02d:00+0900",2011,$6,$7,$8,$9);
		$maxpower=~s/\,//;
		$maxpower=~s/\s//;
	}
	# ４行目　スキップ
	$tmp=<R>;

	# ５行目 予想最大電力
	# 予想最大電力(万kW),時間帯（自）,時間帯（至）,予想最大電力情報更新日,予想最大電力情報更新時刻
	$tmp=<R>;
	$tmp=~s/\n//g;
	if($tmp=~/^\"(.+)\"\,(\d+)\:(\d+)\,(\d+)\:(\d+)\,(\d+)\/(\d+)\,(\d+)\:(\d+)/) {
		$juyou=$1;
		$time1="$2:$3";
		$time2="$4:$5";
		$juyou=~s/\,//;
		$juyou=~s/\s//;
	}
	# ６行目 スキップ
	$tmp=<R>;
	close(R);

	$persent=int(($juyou+0) / ($maxpower+0)*100);
	$text=<<EOM;
@{[$date]}の東京電力の見通し
情報更新日時：$update

ピーク時供給力：@{[$maxpower]}万kW
予想最大電力　：@{[$juyou]}万kW
予想最大使用率：@{[$persent]}％
ピーク時間帯　：@{[$time1]}-@{[$time2]}
EOM

	$html=<<EOM;
<p>
東京電力@{[$date]}の見通し(@{[$update]}更新)<br />
ピーク時供給力:@{[$maxpower]}万kW&nbsp;
予想最大電力:</td><td>@{[$juyou]}万kW&nbsp;
予想最大使用率:</td><td>@{[$persent]}％&nbsp;
ピーク時間帯:</td><td>@{[$time1]}～@{[$time2]}&nbsp;
</p>
EOM

	$mhtml=<<EOM;
@{[$date]}予報<br />(@{[$update]}更新)<br />
<table>
<tr><td>供給力:</td><td>@{[$maxpower]}万kW</td></tr>
<tr><td>最大電力:</td><td>@{[$juyou]}万kW</td></tr>
<tr><td>使用率:</td><td>@{[$persent]}％</td></tr>
<tr><td>時間帯:</td><td>@{[$time1]}～@{[$time2]}</td></tr>
</table>
EOM

	$xml=<<EOM;
<item rdf:about="Llink">
<title>東京電力<![CDATA[@{[$date]}の見通し (@{[$update]}更新)]]></title>
<link>http://denkiyohou.daiba.cx/</link>
<description><![CDATA[ピーク時供給力：@{[$maxpower]}万kW<br />
予想最大電力　：@{[$juyou]}万kW<br />
予想最大使用率：@{[$persent]}％<br />
ピーク時間帯　：@{[$time1]}～@{[$time2]}]]></description>
<dc:date>$rssdate</dc:date>
</item>
EOM
	if(open(R,"$writefilelist")) {
		foreach(<R>) {
			chomp;
			my $file=$_;
			if(open(W,">:utf8","$file")) {
				if($file=~/\.html$/) {
					print W $html;
				} elsif($file=~/\.mhtml$/) {
					print W $mhtml;
				} elsif($file=~/\.xml$/) {
					print W $xml;
				} else {
					print W $text;
				}
				close(W);
			}
		}
		close(R);
	}
}
